{
| RPasN - Calculadora de Notacao Reversa Polonesa (RPN)
| Copyright (c) Alexandre Erwin Ittner - 2000
| kernel32@bigfoot.com
| http://kernel32.cjb.net
|
| Este programa e' um software livre que pode ser
| copiado e distribuido segundo GPL 2, conforme
| publicado pela Free Software Foundation. NAO 
| EXISTE NENHUMA GARANTIA, EXPRESSA OU IMPLICITA!
|
}

Unit comandos;

interface

uses 	crt,
	upilha,
	interfac,
	matemat,
	rstrings,
	definic,
	referen,
	sysutils;

function interpreta_comando:boolean;
procedure interpreta_script(nome_arquivo:string);
procedure depurascript;



implementation
procedure interpreta_script(nome_arquivo:string);
var	arq_script:text;
	linha:integer;
	comando_interpretado:boolean;
begin
	if fileexists(nome_arquivo) then
		begin
		assign(arq_script, nome_arquivo);
		reset(arq_script);
		linha := 0;
		repeat
			readln(arq_script, comando);
			linha := linha + 1;
			comando_interpretado := interpreta_comando;
		until eof(arq_script) or (not comando_interpretado);
		close(arq_script);

		comando := '#'; {impede a permanencia do ultimo comanod do
				 script na linha de comando}

		if comando_interpretado = true then
			aviso := 'Script executado'
		else	
			aviso := aviso + ' - Script abortado (linha ' + inttostr(linha) + ')';
		end
	else
		aviso := 'Script nao encontrado';
	end;






procedure depurascript;
var	nome_arquivo:string;
	arq_script:text;
	num_linha:integer;
	opcao:char;
	temp:integer;
begin
	nome_arquivo := '';
	titulo;
	write(' Nome do script: ');
	readln(nome_arquivo);
	nome_arquivo := dir_scripts + nome_arquivo + '.rps';

	if fileexists(nome_arquivo) then
		begin
		assign(arq_script, nome_arquivo);
		reset(arq_script);
		aviso := 'Depuracao de script';
		num_linha := 0;
		while not eof(arq_script) do
			begin
			readln(arq_script, comando);
			num_linha := num_linha + 1;
			titulo;
			mostrapilha(20);

			if length(nome_arquivo) < 15 then
				write(' ', nome_arquivo)
			else
				begin
				write(' ...');
				for temp := length(nome_arquivo) - 15 to length(nome_arquivo) do
					write(nome_arquivo[temp]);
				end;

			{ menu maldito!!! }
			write(' - linha ', num_linha, ' - ');
			textcolor(texto_negrito);
			write('E');
			textcolor(texto_normal);
			write('xecutar ');
			textcolor(texto_negrito);
			write('S');
			textcolor(texto_normal);
			write('altar ');
			textcolor(texto_negrito);
			write('C');
			textcolor(texto_normal);
			write('ancelar ');

			writeln('');
			write(' Calc RPN: ', comando);

			repeat 
				opcao := readkey;
				opcao := upcase(opcao);
			until (opcao = 'S') or (opcao = 'C') or (opcao = 'E');

			if not ((opcao = 'S') or (opcao = 'C')) then
				interpreta_comando;

			if opcao = 'C' then
				begin
				aviso := 'Execucao cancelada';
				exit;
				end;
			end;
		close(arq_script);
		comando := '#'; 
		end
	else
		aviso := 'Script nao encontrado';
	end;





function interpreta_comando:boolean;
var	nome_arquivo:string;
	temp_str:string;
	erro:integer;
	comando_ok:boolean;
	temp_x:real;
	i:integer;
	texto_comando:string;
	houve_erro:boolean;

begin
	comando_ok := false;
	houve_erro := false;
	comando := retorna_referencia(comando);
	texto_comando := comando;
	comando := formatacomando(comando);

	if (comando = 'DEP') and (comando_ok = false) then
		begin
		depurascript;
		comando_ok := true;
		end;

	if (comando = 'DUP') and (comando_ok = false) then
		begin
		inserir(pilha[1]);
		aviso := 'Elemento duplicado';
		comando_ok := true;
		end;

	if (comando = 'DROP') and (comando_ok = false) then
		begin
		excluir;
		aviso := 'Ultimo elemento retirado';
		comando_ok := true;
		end;

	if (comando = 'CLEAR') and (comando_ok = false) then
		begin
		limpa_pilha;
		aviso := 'Pilha esvaziada';
		comando_ok := true;
		end;

	if (comando = 'SWAP') and (comando_ok = false) then
		begin
		temp_x := pilha[1];
		pilha[1] := pilha[2];
		pilha[2] := temp_x;
		aviso := 'Elementos trocados';
		comando_ok := true;
		end;

	if (comando = 'PICK') and (comando_ok = false) then
		begin
		i := trunc(pilha[1]);
		if  (i > 0) and (i < pilha_max) then
			begin
			pilha[1] := pilha[i];
			aviso := 'PICK!';
			end
		else
			begin
			aviso := 'ERRO: Impossivel localizar o elemento indicado';
			houve_erro := true;
			end;
		comando_ok := true;
		end;

	if (comando[1] = '@') and (comando_ok = false) then
		begin
		temp_str := remove_1o(comando);
		val(temp_str, i, erro);
		if  (i > 0) and (i < pilha_max) and (erro = 0) then
			begin
			inserir(pilha[i]);
			aviso := 'Elemento n' + temp_str + ' adicionado';
			end
		else
			begin
			aviso := 'ERRO: Impossivel localizar o elemento indicado';
			houve_erro := true;
			end;
		comando_ok := true;
		end;

	if (comando[1] = '?') and (comando_ok = false) then
		begin
		houve_erro := not prompt(texto_comando);
		comando_ok := true;
		end;

	if (comando[1] = '#') and (comando_ok = false) then
		comando_ok := true;
		{ # pode ser usado como comentario em
		scripts }

	if (comando = '+') and (comando_ok = false) then
		begin
		temp_x := pilha[2] + pilha[1];
		excluir;
		excluir;
		inserir(temp_x);
		aviso := 'Adicao: OK';
		comando_ok := true;
		end;

	if (comando = '-') and (comando_ok = false) then
		begin
		temp_x := pilha[2] - pilha[1];
		excluir;
		excluir;
		inserir(temp_x);
		aviso := 'Subtracao: OK';
		comando_ok := true;
		end;

	if (comando = '*') and (comando_ok = false) then
		begin
		temp_x := pilha[2] * pilha[1];
		excluir;
		excluir;
		inserir(temp_x);
		aviso := 'Multiplicacao: OK';
		comando_ok := true;
		end;

	if (comando = '/') and (comando_ok = false) then
		begin
		if pilha[1] <> 0 then 
			begin
			temp_x := pilha[2] / pilha[1];
			excluir;
			excluir;
			inserir(temp_x);
			aviso := 'Divisao: OK';
			end
		else
			if pilha[2] = 0 then
				begin
				aviso := 'ERRO: Resultado indefinido';
				houve_erro := true;
				end
			else
				begin
				aviso := 'ERRO: Resultado infinito';
				houve_erro := true;
				end;
		comando_ok := true;
		end;

	if (comando = '^') and (comando_ok = false) then
		begin
		if pilha[2] = 0 then
			begin
			excluir;
			pilha[1] := 0;
			end
		else
			begin		
			temp_x := exp(ln(abs(pilha[2])) * pilha[1]);
				{ ^^^^ da onde veio isso?? ^^^^}
			excluir;
			excluir;
			inserir(temp_x);
			end;
		aviso := 'Potencia: OK';
		comando_ok := true;
		end;

	if (comando = 'RAIZQ') and (comando_ok = false) then
		begin
		if pilha[1] > 0 then 
			begin
			pilha[1] := sqrt(pilha[1]);
			aviso := 'Raiz Quadrada: OK';
			end
		else
			begin
			aviso := 'ERRO: Resultado complexo';
			houve_erro := true;
			end;
		comando_ok := true;
		end;

	if (comando = 'RAIZ') and (comando_ok = false) then
		begin
		if (pilha[1] > 0) and (pilha[2] > 0) then
			begin
			temp_x := exp(ln(abs(pilha[2])) *(1/pilha[1]));
			excluir;
			pilha[1] := temp_x;
			aviso := 'Raiz: OK';
			end
		else
			begin
			aviso := 'ERRO: Raiz invalida';
			houve_erro := true;
			end;
		comando_ok := true;
		end;
	
	if (comando = 'LOG') and (comando_ok = false) then
		begin
		if pilha[1] > 0 then
			begin
			pilha[1] := ln(pilha[1]) / ln(10);
			aviso := 'Logaritmo decimal: OK';
			end
		else
			begin
			aviso := 'ERRO: Resultado infinito';
			houve_erro := true;
			end;
		comando_ok := true;
		end;

	if (comando = 'LOGX') and (comando_ok = false) then
		begin
		if (pilha[1] > 0) and (pilha[2] > 0) then
			begin
			temp_x := ln(pilha[2]) / ln(pilha[1]);
			excluir;
			excluir;
			inserir(temp_x);
			aviso := 'Logaritmo de base x: OK';
			end
		else
			begin
			aviso := 'ERRO: Resultado infinito';
			houve_erro := true;
			end;
		comando_ok := true;
		end;

	if (comando = 'LN') and (comando_ok = false) then
		begin
		if pilha[1] > 0 then
			begin
			pilha[1] := ln(pilha[1]);
			aviso := 'Logaritmo natural: OK';
			end
		else
			begin
			aviso := 'ERRO: Resultado infinito';
			houve_erro := true;
			end;
		comando_ok := true;
		end;

	if (comando = 'MOD') and (comando_ok = false) then
		begin
		if pilha[1] < 0 then
			pilha[1] := pilha[1] * -1;
		aviso := 'Modulo: OK';
		comando_ok := true;
		end;

	if (comando = 'INV') and (comando_ok = false) then
		begin
		if pilha[1] <> 0 then
			begin
			pilha[1] :=  1/pilha[1];
			aviso := 'Inverso: OK';
			end
		else
			begin
			aviso := 'ERRO: Resultado infinito';
			houve_erro := true;
			end;
		comando_ok := true;
		end;


	if (comando = 'SEN') and (comando_ok = false) then
		begin
		pilha[1] := radianos(pilha[1]);
		pilha[1] := sin(pilha[1]);
		aviso := 'Seno: OK';
		comando_ok := true;
		end;

	if (comando = 'COS') and (comando_ok = false) then
		begin
		pilha[1] := radianos(pilha[1]);
		pilha[1] := cos(pilha[1]);
		aviso := 'Cosseno: OK';
		comando_ok := true;
		end;

	if (comando = 'TAN') and (comando_ok = false) then
		begin
		if (pilha[1] <> 90) and (pilha[1] <> 270) then
			begin
			pilha[1] := radianos(pilha[1]);
			pilha[1] := sin(pilha[1]) / cos(pilha[1]);
			aviso := 'Tangente: OK';
			end
		else
			begin
			aviso := 'ERRO: Resultado infinito';
			houve_erro := true;
			end;
		comando_ok := true;
		end;

	if (comando = 'GRAUS') and (comando_ok = false) then
		begin
		pilha[1] := graus(pilha[1]);
		aviso := 'Conversao radianos -> graus: OK';
		comando_ok := true;
		end;

	if (comando = 'RAD') and (comando_ok = false) then
		begin
		pilha[1] := radianos(pilha[1]);
		aviso := 'Conversao graus -> radianos: OK';
		comando_ok := true;
		end;

	if (comando = 'NEG') and (comando_ok = false) then
		begin
		if pilha[1] <> 0 then
			pilha[1] := pilha[1] * -1;
		aviso := 'Sinal trocado';
		comando_ok := true;
		end;

	if (comando = '!') and (comando_ok = false) then
		begin
		if pilha[1] > 1 then
			begin
			temp_x := pilha[1];
			while temp_x > 1 do
				begin
				temp_x := temp_x - 1;
				pilha[1] := pilha[1] * temp_x;
				end;
			aviso := 'Fatorial: OK'; 
			end
		else
			begin
			aviso := 'ERRO: Argumento deve ser maior que 1';
			houve_erro := true;
			end;
		comando_ok := true;
		end;

	if (comando = 'PI') and (comando_ok = false) then
		begin
		inserir(pi);
		aviso := 'Valor de PI adicionado a pilha';
		comando_ok := true;
		end;


	if (comando = 'RAND') and (comando_ok = false) then
		begin
		randomize;
		inserir(random);
		aviso := 'Valor aleatorio adicionado a pilha';
		comando_ok := true;
		end;

	if (comando = 'RANDN') and (comando_ok = false) then
		begin
		randomize;
		pilha[1] := trunc(random * pilha[1]);
		aviso := 'Valor aleatorio adicionado a pilha';
		comando_ok := true;
		end;

	if (comando = 'RANDI') and (comando_ok = false) then
		begin
		randomize;
		if pilha[2] < pilha[1] then
			begin
			pilha[2] := trunc(pilha[2] + random * (pilha[1]-pilha[2]));
			excluir;
			aviso := 'Valor aleatorio adicionado a pilha';
			end
		else
			aviso := 'ERRO: Intervalo invalido ';
		comando_ok := true;
		end;


	if (comando = 'ABRIR') and (comando_ok = false) then
		begin
		titulo;
		write(' Nome do arquivo: ');
		readln(nome_arquivo);
		aviso := carrega_pilha(nome_arquivo);
		comando_ok := true;
		end;			

	if (comando = 'SALVAR') and (comando_ok = false) then 
		begin
		titulo;
		write(' Nome do arquivo: ');
		readln(nome_arquivo);
		salva_pilha(nome_arquivo);
		aviso := 'Pilha salva para o arquivo';
		comando_ok := true;
		end;

	if (comando = 'REFERENCIAS') and (comando_ok = false) then
		begin
		comando_ok := true;
		mostra_ajuda(arq_referencias);
		aviso := 'OK';
		end;

	if (comando = 'COMANDOS') and (comando_ok = false) then
		begin
		comando_ok := true;
		mostra_ajuda(arq_ajuda_comandos);
		aviso := 'OK';
		end;

	if (comando = 'LICENCA') and (comando_ok = false) then
		begin
		comando_ok := true;
		mostra_ajuda(arq_ajuda_licenca);
		aviso := 'OK';
		end;

	if (comando = 'VERSAO') and (comando_ok = false) then
		begin
		titulo;
		mostraversao;
		esperatecla;
		comando_ok := true;
		aviso := 'OK';
		end;

	if (comando = 'INFO') and (comando_ok = false) then
		begin
		mostra_info;
		comando_ok := true;
		aviso := 'OK';
		end;

	if (fileexists(dir_scripts + remove_espacos(texto_comando) + '.rps')) and (comando_ok = false) then
		begin
		interpreta_script(dir_scripts + remove_espacos(texto_comando) + '.rps');
		comando_ok := true;
		end;

	if (comando_ok = false) then
		begin
		val(comando, temp_x, erro);
		if erro = 0 then
			begin
			inserir(temp_x);
			aviso := comando + ' adicionado a pilha';
			end
		else
			if comando <> '' then
				begin
				aviso := 'ERRO: Comando desconhecido';
				houve_erro := true;
				end
			else
				aviso := 'Digite COMANDOS para obter ajuda';
		comando_ok := true;
		end;
	interpreta_comando := not houve_erro;
	end;


begin
end.
